#include "main.h"
#include "atoint64.h"

#if !defined(HAVE_ATOLL) && !defined(HAVE_STROLL)
static M_int64 M_atoint64(const char *s)
{
	M_int64 ret = 0;
	int is_negative = 0;

	/* Skip leading whitespace */
	while (*s == ' ' || *s == '\t' || *s == '\r' || *s == '\n') {
		s++;
	}

	/* Check for leading sign */
	if (*s == '-') {
		s++;
		is_negative = 1;
	} else if (*s == '+') {
		s++;
	}

	while (*s) {
		if (*s == '-') {
			/* Trailing - sign */
			is_negative = 1;
			break;
		} else if (M_isdigit(*s)) {
			ret *= 10;
			ret += *s - '0';
		} else {
			break;
		}

		s++;
	}

	return is_negative
		? ret * -1
		: ret;
}
#endif


M_int64 M_atoll(const char *s)
{
	if (s == NULL)
		return 0;
#if defined(HAVE_ATOLL)
	return atoll(s);
#elif defined(HAVE_STRTOLL)
	return strtoll(s, NULL, 10);
#else
	return M_atoint64(s);
#endif
}
