#ifndef __CSV_H__
#define __CSV_H__ 1

typedef struct Ml_csv_data {
        char ***data_arr;
        int num_rows;
        int num_cols;
        char *data_ptr;
} Ml_csv_data;

void Ml_csv_free(Ml_csv_data *data);
Ml_csv_data *Ml_csv_parse(const char *str, size_t len, char delim, char quote);
Ml_csv_data *Ml_csv_parse_inplace(char *data, size_t len, char delim, char quote);

/* Raw getters if no headers used */
#define Ml_csv_raw_num_rows(csv) ((csv)->num_rows)
#define Ml_csv_raw_num_cols(csv) ((csv)->num_cols)
#define Ml_csv_raw_cell(csv, row, col) (((csv)->num_rows > row && (csv)->num_cols > col)?(csv)->data_arr[row][col]:NULL)

/* getters if headers used (default) */
#define Ml_csv_get_numcols(csv) Ml_csv_raw_num_cols(csv)
#define Ml_csv_get_numrows(csv) (Ml_csv_raw_num_rows(csv)-1)
#define Ml_csv_get_cellbynum(csv, row, col) Ml_csv_raw_cell(csv, row+1, col)
#define Ml_csv_get_header(csv, col) Ml_csv_raw_cell(csv, 0, col)
const char *Ml_csv_get_cell(Ml_csv_data *csv, int row, const char *colname);

#endif
