#include <stdlib.h>
#include <string.h>

#include "mstring.h"
#include "mstdlib.h"

#define M_min(a,b) ((a) <= (b) ? (a) : (b))

int M_strlcpy(char *dest, const char *src, size_t size)
{
	size_t i;

	if (
		dest == NULL ||
		src  == NULL ||
		size == 0
	) {
		return 0;
	}

	i = M_min(strlen(src), size - 1);
	memcpy(dest, src, i);
	dest[i] = '\0';

	return 1;
}

int M_strlcat(char *dest, const char *src, size_t dest_size)
{
	size_t dest_len, src_len, num_to_copy;

	if (
		dest      == NULL ||
		src       == NULL ||
		dest_size == 0
	) {
		return 0;
	}

	dest_len = strlen(dest);
	if (dest_len > dest_size - 1) {
		return 0;
	}

	src_len = strlen(src);

	num_to_copy = M_min(dest_size - dest_len - 1, src_len);
	memcpy(dest + dest_len, src, num_to_copy);

	dest[dest_len + num_to_copy] = '\0';

	return 1;
}

char *Ml_strdup(const char *src)
{
	char *ret;

	if ((src == NULL) || *src == '\0') {
		ret = Ml_malloc(1);
		ret[0] = '\0';
	} else {
		ret = Ml_malloc(strlen(src) + 1);
		strcpy(ret, src);  /* OK use of strcpy */
	}

	return ret;
}
