#ifndef __SNPRINTF_H__
#define __SNPRINTF_H__

#include <stdarg.h>
#ifndef _WIN32
#    include <sys/ioctl.h>
#    include <sys/param.h>
#endif
#include "monetra.h"

#ifndef __printflike
#ifdef __GNUC__
#define __printflike(fmtarg, firstvararg) \
        __attribute__((__format__ (__printf__, fmtarg, firstvararg)))
#else
#define __printflike(fmtarg, firstvararg)
#endif
#endif

/* SNPRINTF REPLACEMENT CALLS */
int Ml_snprintf(char *str, size_t count, const char *fmt,...) __printflike(3, 4);
int Ml_vsnprintf(char *str, size_t count, const char *fmt, va_list args);
int Ml_vasprintf(char **ret, const char *fmt, va_list args);
int Ml_asprintf(char **ret, const char *fmt, ...) __printflike(2, 3);
int Ml_vfprintf(FILE *fp, const char *fmt, va_list args);
int Ml_fprintf(FILE *fp, const char *fmt, ...) __printflike(2, 3);
int Ml_vdprintf(int fd, const char *fmt, va_list args);
int Ml_dprintf(int fd, const char *fmt, ...) __printflike(2, 3);
int Ml_vprintf(const char *fmt, va_list args);
int Ml_printf(const char *fmt, ...) __printflike(1, 2);

#endif
