#ifndef __SOCKETS_H__
#define __SOCKETS_H__

#ifdef HAVE_SYS_TYPES_H
#    include <sys/types.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#    include <sys/socket.h>
#endif

#include "proxy.h"

/* SOCKET COMMUNICATION COMMANDS */
int M_InitSockets(void);
void M_closesocket(int fd, int call_shutdown);
int M_SetNonBlock(int fd, int tf);
int M_gethostbyname(const char *host, char **addr, char *error, int errlen);
int M_ip_connect(M_CONN *myconn);
int connect_nonblock(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen, int maxtime, char *error, int errlen);
long M_read_socket(const char *dbg_head, int dbg_level, char *buf, int buflen, int fd);
long M_write_socket(const char *dbg_head, int dbg_level, const char *buf, int buflen, int fd);
int M_VerifyPing(M_CONN *myconn);
int M_CheckRead_select(int ptr, long delay);
int M_CheckWrite_select(int ptr, long delay);
int M_Monitor_IP(M_CONN *myconn, unsigned long delay);
int M_SendTransaction_IP(M_CONN *myconn, M_uint64 identifier, char *transaction);

#endif
